import { __spreadArray, __assign, __rest } from './../external/tslib/tslib.es6.js';
import React, { useMemo, useState, useCallback, useEffect } from 'react';
import { parseMetadata } from '@highlight-ui/utils-commons';
import { DragAndDropList } from '@highlight-ui/drag-and-drop';
import classnames from 'classnames';
import styles from './Menu.module.scss.js';
import MenuItem from './MenuItem/MenuItem.js';
import { MenuVariants } from './types.js';

function Menu(_a) {
  var _b;

  var items = _a.items,
      onClick = _a.onClick,
      dragProps = _a.dragProps,
      variant = _a.variant,
      metadata = _a.metadata;
  var initialList = useMemo(function () {
    var isActive = items.some(function (_a) {
      var active = _a.active;
      return active;
    });

    if (!items.length) {
      return items;
    }

    if (isActive) {
      return items;
    }

    var firstItem = items[0],
        restItems = items.slice(1);
    return __spreadArray([__assign(__assign({}, firstItem), {
      active: true
    })], restItems, true);
  }, [items]);

  var _c = useState(initialList),
      list = _c[0],
      setList = _c[1];

  var isAnchor = variant === MenuVariants.ANCHOR;
  var onClickHandler = useCallback(function (_a) {
    _a.active;

    var rest = __rest(_a, ["active"]);

    setList(function (prevList) {
      return prevList.map(function (listItem) {
        return __assign(__assign({}, listItem), {
          active: listItem.key === rest.key
        });
      });
    });
    onClick(rest);
  }, [onClick]);
  useEffect(function () {
    setList(initialList);
  }, [initialList]);
  return /*#__PURE__*/React.createElement("div", __assign({
    className: classnames(styles.droppableZoneWrapper, (_b = {}, _b[styles.anchorMenu] = isAnchor, _b))
  }, parseMetadata(metadata)), /*#__PURE__*/React.createElement(DragAndDropList, {
    list: list,
    dragProps: dragProps,
    listItemClassName: isAnchor ? styles.anchorMenuItem : styles.defaultMenuItem,
    renderItem: function (_a) {
      var item = _a.item,
          dragRef = _a.dragRef,
          isOver = _a.isOver,
          canDrop = _a.canDrop;
      return /*#__PURE__*/React.createElement(MenuItem, {
        item: item,
        isSelected: !!item.active,
        onClick: onClickHandler,
        dragRef: dragRef,
        isOver: isOver,
        canDrop: canDrop,
        variant: variant
      });
    }
  }));
}

export { Menu as default };
//# sourceMappingURL=Menu.js.map
